using System;
using System.IO;
using System.Xml.Serialization;
using System.Collections.Generic;


public abstract class GeomFigure
{
}

public class GeomPoint: GeomFigure
{
    private double xField, yField;        
        
    [XmlAttribute("X")]
    public double X 
    {
        get {return xField;}
        set {xField = value;}
    }       
    
    [XmlAttribute("Y")]
    public double Y 
    {
        get {return yField;}
        set {yField = value;}
    }       
    
    public GeomPoint()
    {
    }
    
    public GeomPoint(double x, double y)
    {
        xField = x;
        yField = y;
    }    
    
    public override string ToString()
    {
        return String.Format("({0}, {1})", X, Y);
    }
}

public class GeomLine: GeomFigure
{
    private GeomPoint aField, bField;        
        
    public GeomPoint A 
    {
        get {return aField;}
        set {aField = value;}
    }       
    
    public GeomPoint B
    {
        get {return bField;}
        set {bField = value;}
    }       
    
    public GeomLine()
    {
    }
    
    public GeomLine(GeomPoint a, GeomPoint b)
    {
        aField = a;
        bField = b;
    }
    
    public override string ToString()
    {
        return String.Format("{0} {1}", A, B);
    }
}

[XmlRoot("")]    
public class GeomFigures    
{      
    private List<GeomFigure> figuresField;
   
    //~ [XmlArrayItem("Point", typeof(GeomPoint)), 
    //~ XmlArrayItem("Line", typeof(GeomLine))]    
    [XmlElement("Point", typeof(GeomPoint)), 
    XmlElement("Line", typeof(GeomLine))]    
    public List<GeomFigure> Figures
    {
        get { return figuresField;}
    }
    
    public GeomFigures()
    {
        figuresField = new List<GeomFigure>();
    }
    
    //~ public void Print()
    //~ {        
        //~ foreach (GeomFigure figure in Figures) 
        //~ {
            //~ Console.WriteLine(figure);
        //~ }
    //~ }    
}

public class App
{
   public static void Main()
   {
        GeomFigures figures = new GeomFigures();
       
        figures.Figures.Add(new GeomPoint(2, -1));
        figures.Figures.Add(new GeomLine(new GeomPoint(-1, -1), 
            new GeomPoint(2, 2)));
       
//        figures.Print();
        //
        XmlSerializer serializer = new XmlSerializer(typeof(GeomFigures));
        using (StreamWriter writer = new StreamWriter("figures.xml"))
        {
            serializer.Serialize(writer, figures);
        };
   }
}   
