using System;
using System.Xml;
using System.Threading;
using System.Messaging;
using System.Collections.Generic;

using Seva.Msmq;
using Seva.ApplicationLogs; 
using Seva.Programm;

using Seva.Math.DistributedIntegration;

namespace MsmqApplication
{
    class FunctionsList: List<String>
    {
        //public readonly ArrayList functions;
        
        public FunctionsList(String fileName)
        {
            //functions = new ArrayList();
            
            XmlReader reader = new XmlTextReader(fileName); //StreamReader file = new StreamReader
            /*reader.Read();
            reader.ReadToNextSibling("functions");*/
            while (reader.Read())//ToDescendant("function"))
            {
                if (reader.NodeType == XmlNodeType.Element)
                    if (reader.LocalName.Equals("function"))
                        /*functions.*/Add(reader.ReadString());         
            }
            //XPathDocument document = new XPathDocument(file);
            
        }       
    }       
    
    class MessageSender
    {
        private MsmqClient<IntegrationRequest, IntegrationAnswer> msmq;            
        private FunctionsList functionsList;
        
        public MessageSender(String queueSendName, String queueReceiveName)
        {
            msmq = new MsmqClient<IntegrationRequest, IntegrationAnswer>(queueSendName, 
                queueReceiveName, QueueFormatter.Xml);
            msmq.ProcessAnswer += ProcessAnswer;
            functionsList = new FunctionsList(ProgrammConfig.FunctionsFileName);
        }   
        
        public void Run()
        {
            msmq.BeginReceive();
            //for(Int32 i = 0; i<6; i++)
            while (true)
            {                
                IntegrationRequest request = GetRequest();
                msmq.Send(request);
                Log.Message("Request: for {0}, waiting: {1}",   request.ToString(), msmq.Messages.Count);
                Thread.Sleep(TimeSpan.FromSeconds(2));
            }               
           msmq.EndReceive();
        }   
        
        public IntegrationRequest GetRequest()
        {
            const double delta = 50;
            Random random = new Random();
            double x1 = (random.NextDouble() - 0.5)*delta;
            double x2 = (random.NextDouble() - 0.5)*delta;
            if (x1>x2)
            {
                double tmp =x1;
                x1=x2;
                x2=tmp;
            }   
            String function  = (String) functionsList[random.Next(functionsList.Count)];
            
            return new IntegrationRequest(function, x1, x2, 0.000001);            
        }   
        
        public void ProcessAnswer(Object sender, IntegrationRequest request,
            IntegrationAnswer answer)
        {
            Log.Message("{0}", answer.ToString());
        }
            
    }       
    
    class ClientProgram
    {
        static public void Main()
        {
            Log.Message(Messages.msmqConfig1,
                       ProgrammConfig.OrderQueueName, ProgrammConfig.ResponseQueueName);
            
            Log.Start(Messages.msmqCheckQueues);
            MessageSender  sender = 
                new MessageSender(ProgrammConfig.OrderQueueName, 
                                ProgrammConfig.ResponseQueueName);
            Log.Finish();       
            
            Log.Message(Messages.msmqSendingMessage);
            sender.Run();              
        }
    }
}