// LceSubscriber.cs

using System;
using System.IO;
using System.Threading;
using System.Runtime.InteropServices;
using System.EnterpriseServices;
using System.Messaging;

using Seva.ComUtils;
using Seva.Msmq;

[assembly: ApplicationName("LCE demo")]
[assembly: ApplicationActivation(ActivationOption.Server)]
[assembly: ApplicationAccessControl(false)]

public static class Consts
{
    public const string comAppName = "LCE demo";   
    public const string testQueue = @".\Private$\sample_queue";        
}

[JustInTimeActivation]
[Transaction(TransactionOption.Required)]
public class LceSubscriber : ServicedComponent, ILceMessage
{       
    public LceSubscriber()
    {
    }

    public void TriggerEvent(string message)
    {        
        MessageQueue queue = MsmqTools.CreateQueue(Consts.testQueue);
        queue.Send(message, MessageQueueTransactionType.Automatic);
        ContextUtil.SetComplete();
    }  
}

class MainApp
{            
    public static void Main()
    {
        //     
        //  
        LceSubscriber subscriber = new LceSubscriber();        
               
        //   
        LceUtils.PermanentSubscription(Consts.comAppName, 
            typeof(LceSubscriber).ToString(),
            EventsGuids.EventClassId, EventsGuids.InterfaceId);     
   }

}

// LceSubscriber.cs