using System;
using ComAdmin;

namespace Seva.ComUtils
{
    public static class LceUtils
    {
        //   
        public static void PermanentSubscription(string appName, 
            string subscriberName, string eventGuid, string interfaceGuid)
        {
            //       COM+ 
            COMAdminCatalog catalog = new ComAdmin.COMAdminCatalogClass(); 
            ICatalogObject CatalogObject = null;
            ICatalogCollection CompCollection = null, SubCollection = null;

            //    COM+ 
            ICatalogCollection AppCollection = (ICatalogCollection) 
                catalog.GetCollection("Applications");
            AppCollection.Populate();

            //      
            for (int Counter = 0; Counter < AppCollection.Count; Counter++)
            {
                CatalogObject = (ICatalogObject) AppCollection.get_Item(Counter);
                if ((String)CatalogObject.Name == appName)
                {
                    //   
                    CompCollection = (ICatalogCollection) 
                    AppCollection.GetCollection("Components", CatalogObject.Key);
                    CompCollection.Populate();
                    break;
                }
            }

            if (CompCollection == null)
            {
                throw new ApplicationException(
                    String.Format("COM+ Application not found : [{0}]", appName));
            }

            //   
            for (int Counter = 0; Counter < CompCollection.Count; Counter++)
            {
                CatalogObject = (ICatalogObject) CompCollection.get_Item(Counter);
                if ((String)CatalogObject.Name == subscriberName)
                {
                    //    
                    SubCollection = (ICatalogCollection)
                    CompCollection.GetCollection(
                    "SubscriptionsForComponent", CatalogObject.Key);
                    SubCollection.Populate();
                    break;
                }
            }

            if (SubCollection == null)             
            {
                throw new ApplicationException(
                    String.Format("Component not found : [{0}]", subscriberName));
            }

            //  
            CatalogObject = (ICatalogObject)SubCollection.Add();
            CatalogObject.set_Value("EventCLSID", "{" + eventGuid + "}");
            CatalogObject.set_Value("Name", "Permanent Subscription");            
            // CatalogObject.set_Value("MethodName", "FireBroadcastMsg");
            CatalogObject.set_Value("InterfaceID", "{" + interfaceGuid + "}");
            CatalogObject.set_Value("Enabled", true);

            //  
            SubCollection.SaveChanges();
        } // Subscribe
       
    } //LceUtils
} // Seva.ComUtils