using System;
using System.EnterpriseServices;

namespace Seva.Swc
{
    public class SwcUtil : IDisposable
    {
        public SwcUtil()
        {
            ServiceDomain.Enter(GetConfig(TransactionOption.Required));
        }
          
        public SwcUtil(TransactionOption transactionOption)
        {
            ServiceDomain.Enter(GetConfig(transactionOption));    
        }
     
        protected virtual ServiceConfig GetConfig(
            TransactionOption transactionOption)
        {
            ServiceConfig config = new ServiceConfig();
                  
            config.Transaction = transactionOption;
          
            config.TrackingEnabled = true;
            config.TrackingAppName = "SwcUtil";
            config.TrackingComponentName = this.GetType().FullName;

            return config;
        }
                
        public void Dispose()
        {
            ServiceDomain.Leave();
        }
    }
}