// AddUser.cs
using System;
using System.IO;
using Seva.WS.Users;

class MainApp
{   
    public static int Main(string[] Args)
    {
        if (Args.Length < 3)
        {
            Console.WriteLine("usage: adduser <users' file> <username> <password> [--hashed]");
            return 1;
        }
        
        UsersList users = new UsersList();        
        string fileName = Args[0];               
        
        if (File.Exists(fileName))
        {
            users = UsersList.Load(fileName);
        }
        
        bool hashed = false;
        if (Args.Length==4) 
        {    
            hashed = Args[3]=="--hashed";
        }
        
        users.NewUser(Args[1], Args[2], hashed);                    
        users.Save(fileName);
        return 0;
    }
}

