using System;
using System.IO;
using Seva.Security.Encryption;


class MainApp
{      
    public static void Main(string[] Args)
    {
               
        if (Args.Length != 2)
        {
            Console.WriteLine("usage: makekey <text_file> <key_file>");
            return;
        }
        
        SymmetricEncryptor encryptor = new SymmetricEncryptor();
        encryptor.LoadKey(Args[1]);
        
        String encryptedFile = Args[0] + ".enc";
        String decryptedFile = Args[0] + ".new";
        
        using(FileStream output = new FileStream(encryptedFile, FileMode.Create, FileAccess.Write))       
        using (Stream input = new FileStream(Args[0], FileMode.Open, FileAccess.Read))
            {            
                byte[] buffer = new byte[input.Length];
                input.Read(buffer, 0, buffer.Length);
                byte[] iv;
                byte[] encrypted = encryptor.EncryptMessage(buffer, out iv);
                output.Write(iv, 0, iv.Length);
                output.Write(encrypted, 0, encrypted.Length);
            }    
            
        using(FileStream output = new FileStream(decryptedFile, FileMode.Create, FileAccess.Write))       
        using (Stream input = new FileStream(encryptedFile, FileMode.Open, FileAccess.Read))
            {   
                byte[] iv = new byte[SymmetricEncryptor.BlockSize];                
                byte[] buffer = new byte[input.Length-iv.Length];
                input.Read(iv, 0, iv.Length);
                input.Read(buffer, 0, buffer.Length);
                
                byte[] decrypted = encryptor.DecryptMessage(buffer, iv);
                output.Write(decrypted, 0, decrypted.Length);
            }                       
    }
}        


