using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;

using Seva.Remoting.MsmqChannel;

public class RemoteService : MarshalByRefObject
{
    public RemoteService()
    {
        // Notify the user that the constructor was invoked.
        Console.WriteLine("Constructor invoked.");
    }

    ~RemoteService()
    {
        Console.WriteLine("Destructor invoked");
    }

    [System.Runtime.Remoting.Messaging.OneWayAttribute]
    public void Hello()
    {
        // Print a simple message.
        Console.WriteLine("Hello invoked!");
    }
}

class MainApp
{      
    
    public static void TestReceiver()
    {
        IChannelReceiver channel = new MsmqReceiver(queue);
        ChannelServices.RegisterChannel(channel, false);
        
        RemoteService service = new RemoteService();
        ObjRef obj = RemotingServices.Marshal(service);//, "TcpService");
        //
        Console.WriteLine("... server registered");
        //
        IChannelSender sender = new MsmqSender();//queue);
        ChannelServices.RegisterChannel(sender, false);
        Console.WriteLine("... client registered");
        //
        RemoteService remote = (RemoteService)
        Activator.GetObject(typeof(RemoteService), remoteurl);
        Console.WriteLine("... remote service created");
        //
        remote.Hello();
        //
        Console.WriteLine("Press enter...");
        Console.ReadLine();
    }
    
    public static void TestMisc()
    {
        /*Regex r = new Regex(@"^(.*)(\\|\/)(.*)$"); 
        // Find a single match in the string.
        Match m = r.Match(@".\Private$\remoting_queue\endpoint"); 
        Console.WriteLine(m.Success);
        Console.WriteLine(m.Groups.Count);
        Console.WriteLine(m.Groups[0]);
        Console.WriteLine(m.Groups[1]);
        Console.WriteLine(m.Groups[2]);
        Console.WriteLine(m.Groups[3]);*/
        
        string uri;
        string url = @"msmq://.\Private$\remoting_queue\endpoint";
        Seva.Remoting.MsmqChannel.MsmqSender sender = new Seva.Remoting.MsmqChannel.MsmqSender();
        sender.CreateMessageSink(url, null, out uri);
        Console.WriteLine(uri);

        //~ System.Runtime.Remoting.Channels.Http.HttpChannel c  = 
            //~ new System.Runtime.Remoting.Channels.Http.HttpChannel();
        //~ Console.WriteLine(c.ChannelName);
        
        string lurl = @".\Private$\remoting_queue\endpoint";
        //~ // "msmq://localhost:queue/endpoint";
        string path;
        string url1 = Seva.Remoting.MsmqChannel.Utils.ParseLogicalUrl(lurl, out path);
        Console.WriteLine(String.Format("Url: [{0}]; Queue: [{1}]", url1, path));
    }
    
    public static void Main()
    {
        TestReceiver();
    }
}